package services

import (
	"encoding/json"
	"errors"
	"fmt"
	"hongze/hz_eta_api/services/alarm_msg"
	"hongze/hz_eta_api/utils"
	"io/ioutil"
	"net/http"
	"net/url"
)

func SendSmsCode(mobile, ip string, codeType int, vcode string) bool {
	flag := false
	tplId := ""
	switch codeType {
	case utils.REGISTER_CODE:
		tplId = "206722"
	case utils.LOGIN_CODE:
		tplId = "65692"
	}
	result, err := sendSms(mobile, tplId, vcode)
	if err != nil {
		fmt.Println("发送短信失败")
		return false
	}
	fmt.Println("result", string(result))
	var netReturn map[string]interface{}
	err = json.Unmarshal(result, &netReturn)
	if err != nil {
		go alarm_msg.SendAlarmMsg("短信验证码发送失败 ErrMsg:"+err.Error()+" result"+string(result), 3)
		//go utils.SendEmail("短信验证码发送失败","err:"+err.Error()+" result"+string(result), utils.EmailSendToUsers)
		flag = false
	}
	if netReturn["error_code"].(float64) == 0 {
		fmt.Printf("接口返回result字段是:\r\n%v", netReturn["result"])
		flag = true
	} else {
		go alarm_msg.SendAlarmMsg("短信验证码发送失败 ErrMsg:"+err.Error()+" result"+string(result), 3)
		//go utils.SendEmail("短信验证码发送失败"," result"+string(result), utils.EmailSendToUsers)
		flag = false
	}
	return flag
}

func sendSms(mobile, tplId, code string) (rs []byte, err error) {
	if utils.JhGnAppKey == `` {
		err = errors.New("短信未配置")
		return
	}
	var Url *url.URL
	apiURL := "http://v.juhe.cn/sms/send"
	//初始化参数
	param := url.Values{}
	//配置请求参数,方法内部已处理urlencode问题,中文参数可以直接传参
	param.Set("mobile", mobile)            //接受短信的用户手机号码
	param.Set("tpl_id", tplId)             //您申请的短信模板ID，根据实际情况修改
	param.Set("tpl_value", "#code#="+code) //您设置的模板变量，根据实际情况
	param.Set("key", utils.JhGnAppKey)     //应用APPKEY(应用详细页查询)

	Url, err = url.Parse(apiURL)
	if err != nil {
		fmt.Printf("解析url错误:\r\n%v", err)
		return nil, err
	}
	//如果参数中有中文参数,这个方法会进行URLEncode
	Url.RawQuery = param.Encode()
	resp, err := http.Get(Url.String())
	if err != nil {
		fmt.Println("err:", err)
		return nil, err
	}
	defer resp.Body.Close()
	return ioutil.ReadAll(resp.Body)
}
